#include<bits/stdc++.h>
using namespace std ;


const int N = 303 ;
const int K = 603 ;
const int M = 2e6 + 2 ; 
int T , n , m , k ;
int a[M] ;

void deal1()
{
//	int cnt[3][M] ;
	cin>>n>>m>>k ;
	for (int i = 1 ; i <= m ; i ++ )
	{
		cin>>a[i] ;
//		cnt[a[i]][++mx[a[i]]] = i ;
	}
	cout<<5<<endl ;
	for (int i = 1 ; i <= m + 1 ; i ++)
	{
		if (i != 4)	cout<<1<<" "<<1<<endl ;
		else if (i != 3) 
		{
			cout<<2<<" "<<1<<" "<<2<<endl; 
		}
		else if (i == 3 )
		{
			cout<<1<<" "<<2<<endl ;
		}
	}
}
int main()
{
	
	freopen("meow.in","r",stdin) ;
	freopen("meow.out","w",stdout) ;
	
	cin>>T ;
	if (T % 10 == 2 || T % 10 ==3 )
	{
		if (T % 10 == 2)
		{
			deal1() ;
		}
	}
	return 0 ;
}